PROGRAM uuencode;

USES
  Crt;

  CONST header = 'begin';
        trailer = 'end';
        defaultMode = '644';
        defaultExtension = '.uue';
        offset = 32;
        charsPerLine = 60;
        bytesPerHunk = 3;
        sixBitMask = $3F;

  TYPE STRING80 = STRING[80];

  VAR infile: FILE OF Byte;
      outfile: Text;
      infilename, outfilename, mode: STRING80;
      lineLength, numbytes, bytesInLine: Integer;
      Line: ARRAY [0..59] OF Char;
      hunk: ARRAY [0..2] OF Byte;
      chars: ARRAY [0..3] OF Word;

{  procedure debug;

    var i: integer;

    procedure writebin(x: byte);

      var i: integer;

      begin
        for i := 1 to 8 do
          begin
            write ((x and $80) shr 7);
            x := x shl 1
          end;
        write (' ')
      end;

    begin
      for i := 0 to 2 do writebin(hunk[i]);
      writeln;
      for i := 0 to 3 do writebin(chars[i]);
      writeln;
      for i := 0 to 3 do writebin(chars[i] and sixBitMask);
      writeln
    end;  }

  PROCEDURE Abort (message: STRING80);

    BEGIN {abort}
      Writeln(message);
      Close(infile);
      Close(outfile);
      Halt
    END; {abort}

  PROCEDURE Init;

    PROCEDURE GetFiles;

      VAR i: Integer;
          temp: STRING80;
          ch: Char;

      BEGIN {GetFiles}
        IF ParamCount < 1 THEN abort ('No input file specified.');
        infilename := ParamStr(1);
        {$I-}
        Assign (infile, infilename);
        Reset (infile);
        {$i+}
        IF IOresult > 0 THEN abort (Concat ('Can''t open file ', infilename));
        Write('Uuencoding file ', infilename);

        i := Pos('.', infilename);
        IF i = 0
          THEN outfilename := infilename
          ELSE outfilename := Copy (infilename, 1, Pred(i));
        mode := defaultMode;
        IF ParamCount > 1 THEN
          FOR i := 2 TO ParamCount DO
            BEGIN
              temp := ParamStr(i);
              IF temp[1] IN ['0'..'9']
                THEN mode := temp
                ELSE outfilename := temp
            END;
        IF Pos ('.', outfilename) = 0
          THEN outfilename := Concat(outfilename, defaultExtension);
        Assign (outfile, outfilename);
        Writeln (' to file ', outfilename, '.');

        {$i-}
        Reset(outfile);
        {$i+}
        IF IOresult = 0 THEN
          BEGIN
            Write ('Overwrite current ', outfilename, '? [Y/N] ');
            REPEAT
              ch:=ReadKey;
              ch := UpCase(ch)
            UNTIL ch IN ['Y', 'N'];
            Writeln (ch);
            IF ch = 'N' THEN abort(Concat (outfilename, ' not overwritten.'))
          END;
        (*close(outfile); liikaa tss *)

        {$i-}
        Rewrite(outfile);
        {$i+}
        IF IOresult > 0 THEN abort(Concat('Can''t open ', outfilename));
      END; {getfiles}

    BEGIN {Init}
      GetFiles;
      bytesInLine := 0;
      lineLength := 0;
      numbytes := 0;
      Writeln (outfile, header, ' ', mode, ' ', infilename);
    END; {init}

  PROCEDURE FlushLine;

    VAR i: Integer;

    PROCEDURE writeout(ch: Char);

      BEGIN {writeout}
        IF ch = ' ' THEN Write(outfile, '`')
                    ELSE Write(outfile, ch)
      END; {writeout}

    BEGIN {FlushLine}
      Write ('.');
      writeout(Chr(bytesInLine + offset));
      FOR i := 0 TO Pred(lineLength) DO
        writeout(Line[i]);
      Writeln (outfile);
      lineLength := 0;
      bytesInLine := 0
    END; {FlushLine}

  PROCEDURE FlushHunk;

    VAR i: Integer;

    BEGIN {FlushHunk}
      IF lineLength = charsPerLine THEN FlushLine;
      chars[0] := hunk[0] SHR 2;
      chars[1] := (hunk[0] SHL 4) + (hunk[1] SHR 4);
      chars[2] := (hunk[1] SHL 2) + (hunk[2] SHR 6);
      chars[3] := hunk[2] AND sixBitMask;
      {debug;}
      FOR i := 0 TO 3 DO
        BEGIN
          Line[lineLength] := Chr((chars[i] AND sixBitMask) + offset);
          {write(line[linelength]:2);}
          lineLength := Succ(lineLength)
        END;
      {writeln;}
      bytesInLine := bytesInLine + numbytes;
      numbytes := 0
    END; {FlushHunk}

  PROCEDURE encode1;

    BEGIN {encode1};
      IF numbytes = bytesperhunk THEN flushhunk;
      Read (infile, hunk[numbytes]);
      numbytes := Succ(numbytes)
    END; {encode1}

  PROCEDURE terminate;

    BEGIN {terminate}
      IF numbytes > 0 THEN flushhunk;
      IF lineLength > 0
        THEN
          BEGIN
            flushLine;
            flushLine;
          END
        ELSE flushline;
      Writeln (outfile, trailer);
      Close (outfile);
      Close (infile);
    END; {terminate}


  BEGIN {uuencode}
    init;
    WHILE NOT EOF (infile) DO encode1;
    terminate
  END. {uuencode}
